package nimapplet;

/**
 * Package nimapplet
 * Jeu de Nim contre un rseau de McCulloch-Pitts.
 * Rseaux Neauronaux, Vuibert 2006.
 * Jean-Philippe Rennard
 * version 1.0, 17/3/2006
 */

import java.awt.*;
import java.awt.event.*;
import baseui.*;

/**
 * <p>Title: Interface utilisateur</p>
 * <p>Description: Interface utilisateur du jeu de Nim.</p>
 */
public class NimUI extends Cui { // Frame Cui
  /** Applet */
  public NimMP applet;
  /** processus */
  public NimProcess partieNim;

  BorderLayout borderLayout1 = new BorderLayout();
  Label statusBar = new Label();
  Panel panel1 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panel2 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel3 = new Panel();
  Button btn1 = new Button();
  Panel panel4 = new Panel();
  Button btn3 = new Button();
  GridLayout gridLayout2 = new GridLayout();
  Button btn2 = new Button();
  GridLayout gridLayout3 = new GridLayout();
  Button btnPasse = new Button();
  Button btNew = new Button();
  Panel panelVue = new Panel();
  GridLayout gridLayout4 = new GridLayout();
  Button btnAbout = new Button();


  public NimUI(NimMP ap) {
    applet = ap;
    partieNim = new NimProcess(this);
    process = (Cprocess) partieNim;

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setTitle(applet.comments + " " + applet.version + " " + applet.auteur);
    this.addWindowListener(new NimUI_this_windowAdapter(this));
    statusBar.setText(applet.product);
    this.setLayout(borderLayout1);
    panel1.setLayout(borderLayout2);
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    btn1.setLabel("1");
    btn1.addActionListener(new NimUI_btn1_actionAdapter(this));
    btn3.setLabel("3");
    btn3.addActionListener(new NimUI_btn3_actionAdapter(this));
    panel3.setLayout(gridLayout2);
    gridLayout2.setColumns(3);
    btn2.setLabel("2");
    btn2.addActionListener(new NimUI_btn2_actionAdapter(this));
    panel4.setLayout(gridLayout3);
    gridLayout3.setColumns(3);
    btnPasse.setLabel("Passe");
    btnPasse.addActionListener(new NimUI_btnPasse_actionAdapter(this));
    btNew.setLabel("Nouveau jeu");
    btNew.addActionListener(new NimUI_btNew_actionAdapter(this));
    panelVue.setLayout(gridLayout4);
    panelVue.addComponentListener(new NimUI_panelVue_componentAdapter(this));
    btnAbout.setLabel("A propos");
    btnAbout.addActionListener(new NimUI_btnAbout_actionAdapter(this));
    this.add(statusBar, BorderLayout.SOUTH);
    this.add(panel1, BorderLayout.CENTER);
    panel1.add(panel2,  BorderLayout.SOUTH);
    panel2.add(panel3, null);
    panel3.add(btn1, null);
    panel3.add(btn2, null);
    panel3.add(btn3, null);
    panel2.add(panel4, null);
    panel4.add(btnPasse, null);
    panel4.add(btNew, null);
    panel4.add(btnAbout, null);
    panel1.add(panelVue, BorderLayout.CENTER);
    // ajout de la vue
    panelVue.add(partieNim.nimVue,null);
  }

  /** (In)active l'interface */
  public void setInterface(boolean e) {
    ;
  }

  /** Affichage de la gnration */
  public void affGeneration() {
    ;
  }

  /** redimensionnement */
  void panelVue_componentResized(ComponentEvent e) {
    redimUi();
    affText(partieNim.getTexteInfo());
  }
  /** Affichage textes sortie */
  public void affText(String t) {
    statusBar.setText(t);
  }
  /** Passe = changement de joueur */
  void btnPasse_actionPerformed(ActionEvent e) {
    coupOrdi();
  }
  /** Joue 1 */
  void btn1_actionPerformed(ActionEvent e) {
    joue(1);
  }
  /** Joue 2 */
  void btn2_actionPerformed(ActionEvent e) {
    joue(2);
  }
  /** Joue 3 */
  void btn3_actionPerformed(ActionEvent e) {
    joue(3);
  }
  /** joue */
  public void joue(int n) {
    boolean fin=false;
    fin=partieNim.joue(n);
    affText(partieNim.getTexteInfo());
    if(fin) {
      Toolkit.getDefaultToolkit().beep();
      affText("C'est fini vous avez perdu");
    }
    else {
      coupOrdi();
    }
  }
  /** l'ordinateur joue */
  void coupOrdi() {
    boolean fin=false;
    partieNim.changeJoueur();
    fin=partieNim.coupOrdi();
    partieNim.changeJoueur();
    affText(partieNim.getTexteInfo());
    if(fin) {
      Toolkit.getDefaultToolkit().beep();
      affText("C'est fini J'ai perdu");
    }
  }
  /** Nouvelle partie */
  void btNew_actionPerformed(ActionEvent e) {
    partieNim.initJeu();
    partieNim.afficheCoup();
    affText(partieNim.getTexteInfo());
  }

  /** Display Info box */
  void dispInfoBox() {
    String s =  applet.product + "\n"
        + "Version : " + applet.version + ", "
        + applet.date + "\n\n"
        + applet.comments + "\n"
        + applet.auteur + "\n"
        + applet.editeur +"\n"
        + applet.copyright + "\n\n"
        + applet.GNU1 + "\n" + applet.GNU2 + "\n" + applet.GNU3 + "\n";

    CaboutBox aboutBox = new CaboutBox(this, "Classification des couleurs", true);
    aboutBox.dispInfoBox(s);
  }


  void this_windowClosing(WindowEvent e) {
    dispose();
  }

  void btnAbout_actionPerformed(ActionEvent e) {
    dispInfoBox();
  }

}

class NimUI_panelVue_componentAdapter extends java.awt.event.ComponentAdapter {
  NimUI adaptee;

  NimUI_panelVue_componentAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void componentResized(ComponentEvent e) {
    adaptee.panelVue_componentResized(e);
  }
}

class NimUI_btnPasse_actionAdapter implements java.awt.event.ActionListener {
  NimUI adaptee;

  NimUI_btnPasse_actionAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPasse_actionPerformed(e);
  }
}

class NimUI_btn1_actionAdapter implements java.awt.event.ActionListener {
  NimUI adaptee;

  NimUI_btn1_actionAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btn1_actionPerformed(e);
  }
}

class NimUI_btn2_actionAdapter implements java.awt.event.ActionListener {
  NimUI adaptee;

  NimUI_btn2_actionAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btn2_actionPerformed(e);
  }
}

class NimUI_btn3_actionAdapter implements java.awt.event.ActionListener {
  NimUI adaptee;

  NimUI_btn3_actionAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btn3_actionPerformed(e);
  }
}

class NimUI_btNew_actionAdapter implements java.awt.event.ActionListener {
  NimUI adaptee;

  NimUI_btNew_actionAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btNew_actionPerformed(e);
  }
}

class NimUI_this_windowAdapter extends java.awt.event.WindowAdapter {
  NimUI adaptee;

  NimUI_this_windowAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }
}

class NimUI_btnAbout_actionAdapter implements java.awt.event.ActionListener {
  NimUI adaptee;

  NimUI_btnAbout_actionAdapter(NimUI adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnAbout_actionPerformed(e);
  }
}
